/* 
 * ------------------------------------------------------------------
 * Begin.h - Beginning of XPressNet section
 * Created by Robert Heller on Sun Nov  6 11:16:51 2005
 * ------------------------------------------------------------------
 * Modification History: $Log$
 * Modification History: Revision 1.2  2007/04/19 17:23:22  heller
 * Modification History: April 19 Lock Down
 * Modification History:
 * Modification History: Revision 1.1  2005/11/14 20:28:45  heller
 * Modification History: Nov 14, 2005 Lockdown
 * Modification History:
 * Modification History: Revision 1.1  2002/07/28 14:03:50  heller
 * Modification History: Add it copyright notice headers
 * Modification History:
 * ------------------------------------------------------------------
 * Contents:
 * ------------------------------------------------------------------
 *  
 *     Model RR System, Version 2
 *     Copyright (C) 1994,1995,2002-2005  Robert Heller D/B/A Deepwoods Software
 * 			51 Locke Hill Road
 * 			Wendell, MA 01379-9728
 * 
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 *  
 */

/** @defgroup XPressNetModule XPressNetModule
  * @brief XPressNet interface code.
  *
  *	These are C++ classes that interface to the Lenz XPressNet
  * interface used on Lenz DCC Command Units.  There is a low-level collection
  * of C++ classes that handles the low-level Serial I/O interface and there
  * is a higher level interface that defines a Tcl Event to handle the
  * asyncronious aspects of the low-level XPressNet serial I/O, by entering the
  * Lenz XPressnet interface into Tcl's Event processing system.
  *
  * @author Robert Heller \<heller\@deepsoft.com\>
  *
  */

/** @brief Namespace that holds the XPressNet interface code.
  *
  * @author Robert Heller \<heller\@deepsoft.com\>
  *
  */

namespace xpressnet {
};

